#!/usr/bin/perl -w
use strict;
use MongoDB;
use CGI;
use warnings;
use boolean qw(:all);
# no warnings "experimental::smartmatch";
#use Data::Dumper;

### Config ###
my $dname =  "dtel-ix";
my $dbuser =  "dtel-ix";
my $dbpass = "fh49HEF89Bxusm";
#my $dbhost =  "web.dtel-ix.net";
my $dbhost = "109.68.46.87";
my $dbcoll =  "members";

### Connect to MongoDB ###
my $mongo_client = MongoDB->connect('mongodb://' . $dbuser . ':' . $dbpass . '@' . $dbhost . '/' . $dname);
my $mongo_db    = $mongo_client->get_database($dname);
my $mongo_coll  = $mongo_db->get_collection($dbcoll);
# $mongo_client->authenticate($dname, $dbuser, $dbpass);

### Print HTML header ###
my $CGI = CGI->new;
print $CGI->header(-type       => 'text/html',
           -charset    => 'utf-8');
print $CGI->start_html(-style => [
        { 'src' => "/templates/system/css/members.css" }
]);

### Get GET variables ###

my $order = $CGI->param('order');
my $asc = $CGI->param('asc');

if (!defined $order) {$order='eng_name'}
if (!defined $asc) {$asc=1}

### Retrieve information from DB ###
my @res;          
my $c = $mongo_coll
        ->find({active => boolean::true});
while(my $hash=$c->next) 
{
	push(@res, $hash);
}

my @sorted;
my $asc_link;
my @sort_chars = qw(eng_name policy country);
my @sort_digits = qw(asn port_speed);

if ($order ~~ @sort_chars)
    {
        if ($asc==1)
            {
              $asc_link="asc=0";
              @sorted =  sort { lc($a->{$order}) cmp lc($b->{$order})} @res;
            }
        elsif ((!defined $asc)||($asc==0))
            {
                $asc_link="asc=1";
                @sorted =  sort {  lc($b->{$order}) cmp  lc($a->{$order})} @res;
            }
        
    }
elsif ($order ~~ @sort_digits)
    {
        if ($asc==1) 
            {
              $asc_link="asc=0";
              @sorted =  sort {  $a->{$order} <=>  $b->{$order}} @res;
            }
        elsif ((!defined $asc)||($asc==0))
            {
                $asc_link="asc=1";
                @sorted =  sort {  $b->{$order} <=>  $a->{$order}} @res;
            }
    }
else {
    $asc_link="asc=0";
    @sorted =  sort {  lc($a->{$order}) cmp  lc($b->{$order})} @res;
}
#print Dumper(@sorted);
### Print table header ###
print '<table><tr class=head><td width=5px>#</td>';

if ($order =~ "eng_name") {print "<td width=200px><a href=?order=eng_name&$asc_link>Member</a></td>"}  
else {print "<td width=200px><a href=?order=eng_name&asc=1>Member</a></td>"}

if ($order =~ "asn") {print "<td width=60px><a href=?order=asn&$asc_link>AS</a></td>"}  
else {print "<td width=60px><a href=?order=asn&asc=1>AS</a></td>"}


if ($order =~ "policy") {print "<td width=100px><a href=?order=policy&$asc_link>Policy</a></td>"}  
else {print "<td width=100px><a href=?order=policy&asc=1>Policy</a></td>"}

if ($order =~ "country") {print "<td width=60px><a href=?order=country&$asc_link>Country</a></td>"}  
else {print "<td width=60px><a href=?order=country&asc=1>Country</a></td>"}

print "</tr>";

### Print results ###
my $i;
my $cnt = 1;
for $i ( 0 .. $#sorted ) 
{
	# Do not show test clients
	next if $sorted[$i]{test};
	# Do not show clients omitted on website
	next if $sorted[$i]{omit_on_website};	

	printf "<tr class=\"%s\" >\n", 
        ($cnt % 2) ? 'body1' : 'body2';
	print <<TBL_BODY;
		<td>$cnt</td>
		<td><a href=http://$sorted[$i]{web_site} target=_blank>$sorted[$i]{eng_name}</td>
		<td>$sorted[$i]{asn}</td>
		<td>$sorted[$i]{policy}</td>
		<td>$sorted[$i]{country}</td>
		</tr>
TBL_BODY
	++$cnt;
}

print "</table>";

$CGI->end_html; # end the HTML
